#!/usr/bin/env python

"""
Apply real value and position offsets to an ascii columnar data file

FIX: needs help being able to deal with any number of columns

     Copyright (C) 2005  Kurt Schwehr

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$Id: offset.py,v 1.3 2005/10/13 20:31:49 schwehr Exp $

"""

# These values end up in the pydoc web page
__version__ = '$Revision: 1.3 $'.split()[1] # See man ident
__date__ = '$Date: 2005/10/13 20:31:49 $'.split()[1]
__author__ = 'Kurt Schwehr'

import os
import sys


from optparse import OptionParser


from segy_version import VERSION

myparser = OptionParser(usage="%prog [options]",
                      version="%prog "+VERSION+' - '+__version__)
myparser.add_option('-i','--input',dest='infile',default=None,type='string',
                    help='Input file.  Must be white space separated columns')
myparser.add_option('-o','--output',dest='outfile',default=None,type='string',
                    help='Write results to this file')

myparser.add_option('-p','--position',dest='position',default='0',type='int',
                    help='Shift the position of a value to a different row [default: %default]')
myparser.add_option('-V','--value',dest='value',default='0.0',type='float',
                    help='Shift the value of each cell [default: %default]')

from verbosity import BOMBASTIC,VERBOSE,TRACE,TERSE,ALWAYS
import verbosity
verbosity.addVerbosityOptions(myparser)

if __name__ == "__main__":
    (options,args) = myparser.parse_args()

    if (None == options.infile):
        sys.exit("ERROR: must specify input file")

    cols=[]
    for line in open(options.infile,'r').xreadlines():
        values = line.split()
        if len(values)==1:
            values=[values[0],None]
        cols.append(values)
    for i in range(len(cols)):
        if i < options.position: continue
        if len(cols)-options.position < i: break
        newPos = i-options.position
        if None != cols[i][1]:
            print cols[newPos][0],float(cols[i][1])+options.value

